function Create(self)
	self.DoubleClickTimer = Timer();
	self.Clicked = true
	self.GliderEnabled = false
	self.GliderFrame = 0
	self.GliderFrameTarget = 0
	
	--mails self.attachable handler
	local i = 1;
	while i < MovableMan:GetMOIDCount() do
		if MovableMan:GetMOFromID(i).RootID == self.ID and i ~= self.ID then
			self.att = MovableMan:GetMOFromID(i)
			if string.find(self.att.PresetName, "Glider") then
				self.Glider = ToAttachable(self.att)
			end
		end
		i = i + 1
	end
	self.Glider.GetsHitByMOs = false
	self.Head.Frame = math.random(0,2)
end

function Update(self)
  local ctrl = self:GetController()
  if ctrl:IsState(Controller.BODY_CROUCH) then
    if self.Clicked then
      if self.DoubleClickTimer:IsPastSimMS(250) then
        self.DoubleClickTimer:Reset();
      else
        self.GliderEnabled = not self.GliderEnabled
      end
    end
    self.Clicked = false
  else
    self.Clicked = true
  end
  --Aerodynamic stuff
  
  if self.GliderEnabled then
    local strikePoint = self.Glider.Pos + self.Glider:RotateOffset(Vector(0 , 45));
    Strength = SceneMan:CastStrengthRay(self.Glider.Pos, self.Glider:RotateOffset(Vector(0 , 45)) , 10, strikePoint, 0 , 0 , SceneMan.SceneWrapsX);
    local pos = SceneMan:GetLastRayHitPos()
    local strikePoint = self.Glider.Pos + self.Glider:RotateOffset(Vector(0 , -45));
    Strength = SceneMan:CastStrengthRay(self.Glider.Pos, self.Glider:RotateOffset(Vector(0 , -45)) , 10, strikePoint, 0 , 0 , SceneMan.SceneWrapsX);
    local pos2 = SceneMan:GetLastRayHitPos()
    self.GliderFrameTarget = math.max(0 , math.min(SceneMan:ShortestDistance(self.Glider.Pos,pos,SceneMan.SceneWrapsX).Magnitude/5 - 1 , SceneMan:ShortestDistance(self.Glider.Pos,pos2,SceneMan.SceneWrapsX).Magnitude/5 - 1))
    if math.min(8 ,self.GliderFrameTarget) == 8 then
      self.GliderFrameTarget = 12
    end
    if self.MovementState ~= 8 then
      self.MovementState = 8
    else
      self.MovementState = 0
    end
    self.JumpState = 3
    local direction = self.Vel.AbsRadAngle
    
    local AirRessistanceForce = 0.003 * self.AngularVel^2 * self.GliderFrame/self.Mass
    if self.AngularVel > 0 then
      if self.AngularVel - AirRessistanceForce > 0 then
        self.AngularVel = self.AngularVel - AirRessistanceForce
      else
        self.AngularVel = 0
      end
    else
      if self.AngularVel + AirRessistanceForce < 0 then
        self.AngularVel = self.AngularVel + AirRessistanceForce
      else
        self.AngularVel = 0
      end
    end
    local RotAngleVector = Vector(math.cos(self.RotAngle * -1 + math.pi*0.5) , math.sin(self.RotAngle * -1 + math.pi*0.5))
    local AirShadow = (RotAngleVector * (self.Vel.Normalized.X*RotAngleVector.X + self.Vel.Normalized.Y*RotAngleVector.Y)).Magnitude
    local RotAngleVectorPer = RotAngleVector.Perpendicular
    local DirectionalSpeed = (RotAngleVectorPer * (self.Vel.X*RotAngleVectorPer.X + self.Vel.Y*RotAngleVectorPer.Y)).Magnitude
    local negatore = 1
    if (self.Vel.Normalized.X*RotAngleVector.Y - self.Vel.Normalized.Y*RotAngleVector.X) < 0 then
      negatore = -1;
    end

    local DirectionalSpeedX = (RotAngleVector * (self.Vel.X*RotAngleVector.X + self.Vel.Y*RotAngleVector.Y)).Magnitude
  
    local modifier = 0
    if ctrl:IsState(Controller.MOVE_RIGHT) then
      modifier = 90/(100+math.abs(DirectionalSpeedX)^0.5)
    end
    if ctrl:IsState(Controller.MOVE_LEFT)then
      modifier = modifier - 90/(100+math.abs(DirectionalSpeedX)^0.5)
    end
    if ctrl:IsState(Controller.BODY_CROUCH) then
      modifier = modifier * 1.5*(100+math.abs(DirectionalSpeedX)^0.5)/100
    end
    local i = math.floor(0.03*self.Vel.Magnitude^2)
    while i > 0 do
      self.AngularVel = self.AngularVel - math.sin((self.RotAngle + self.AngularVel*0.2 + math.pi*0.5 + modifier - direction)*2) * self.GliderFrame/self.Mass
      i = i - 1
    end
    self.AngularVel = self.AngularVel - math.sin((self.RotAngle + self.AngularVel*0.2 + math.pi*0.5 + modifier - direction)*2)*(0.03*self.Vel.Magnitude^2-math.floor(0.03*self.Vel.Magnitude^2)) * self.GliderFrame/self.Mass
        
    local AirRessistanceForce = AirShadow * -10 * DirectionalSpeed^2 * self.GliderFrame
    if self.Vel.Magnitude - AirRessistanceForce > 0 then
--      self.Vel = self.Vel - RotAngleVectorPer*AirRessistanceForce * negatore
      self:AddAbsForce( RotAngleVectorPer*AirRessistanceForce * negatore,self.Pos );
    else
      self.Vel = self.Vel - DirectionalSpeed
    end
  else
    self.GliderFrameTarget = 0
  end
  if self.GliderFrame <= self.GliderFrameTarget-1 then
    self.GliderFrame = self.GliderFrame + 1
    if self.GliderFrame < 9 then
      if self.HFlipped then
        self.AngularVel = self.AngularVel + 45/self.Mass
      else
        self.AngularVel = self.AngularVel - 45/self.Mass
      end
      self.AngularVel = self.AngularVel * 0.925^(50/self.Mass)
      self:AddAbsForce( self:RotateOffset(Vector(0 , -4500)),self.Pos );
    end
  elseif self.GliderFrame >= self.GliderFrameTarget+1 then
    self.GliderFrame = self.GliderFrame - 1
    if self.GliderFrame < 9 then
      if self.HFlipped then
        self.AngularVel = self.AngularVel - 45/self.Mass
      else
        self.AngularVel = self.AngularVel + 45/self.Mass
      end
      self.AngularVel = self.AngularVel * 1.075^(50/self.Mass)
      self:AddAbsForce( self:RotateOffset(Vector(0 , 4500)),self.Pos );
    end
  else
    self.GliderFrame = self.GliderFrameTarget
  end
  self.Glider.Frame = math.floor(self.GliderFrame)
  if self.GliderFrame == 13 and AirRessistanceForce ~= nil and (self.Glider.Frame == 9 or self.Glider.Frame == 11 or self.Glider.Frame == 12 or self.Glider.Frame == 13) then
    local frameforce = math.abs(DirectionalSpeedX) - math.abs(AirRessistanceForce*0.05)
    if frameforce < -40 then
      self.Glider.Frame = 13
    elseif  frameforce < -20 then
      self.Glider.Frame = 11
    elseif  frameforce < 20 then
      self.Glider.Frame = 12
    else
      self.Glider.Frame = 9
    end
  end
end
